#include<ostream>
#include<fstream>
using namespace std;
#include<cstdlib>

#include"defo.h"
#include"multiint.h"
#include"zgfiles.h"



void copyvector(const double S[],double T[],int pdim)
// T=S
{
  for(int i=1;i<=pdim; i++)
    T[i]=S[i];
}


void copyvector(const double S[],interval T[],int pdim)
// T=S
{
  for(int i=1;i<=pdim; i++)
    T[i]=S[i];
}

void copyvector(const interval S[],interval T[],int pdim)
// T=S
{
  for(int i=1;i<=pdim; i++)
    T[i]=S[i];
}


//7.VI.2008 - nie wiem czemu mi sie to nie linkuje
/*
template<typename SourceType, typename TargetType>
void copyvector(const SourceType S[],TargetType T[],int pdim)
// T=S
{
  for(int i=1;i<=pdim; i++)
    T[i]=S[i];
}

template<>
void copyvector<interval,interval>(const interval S[],interval T[],int pdim);
template<>
void copyvector<double,double>(const double S[],double T[],int pdim);
template<>
void copyvector<double,interval>(const double S[],interval T[],int pdim);
*/



void tointerval(const double x[],interval xi[],int dim)
{
  for(int i=1;i<=dim;i++)
    xi[i]=interval(x[i]);
}

void todouble(const interval xi[],double x[],int dim)
// x=mid(xi)
{
  for(int i=1;i<=dim;i++)
    x[i]=mid(xi[i]).left_b();
}

void todouble(const interval xi[][MAX_DIM+1],double x[][MAX_DIM+1], int dim)
{
 for(int i=1;i<=dim;i++)
   for(int j=1;j<=dim;j++)
    x[i][j]=mid(xi[i][j]).left_b();
}

void tointerval(const double x[][MAX_DIM+1],interval xi[][MAX_DIM+1], int dim)
//  xi=x
{
 for(int i=1;i<=dim;i++)
   for(int j=1;j<=dim;j++)
    xi[i][j]=interval(x[i][j]);
}


interval inf_increase_interval(const interval &inter,double d)
//  increases the diameter of <inter> by a tiny amount
{

  double l,r;
  #ifdef UP_ROUNDING
    l=inter.left_b();
    if (l==0.0) l=-d;
    else dec_double(&l);

    r=inter.right_b()+d;
  #else
    l=inter.left_b();
    if (l==0.0) l=-d;
    else {
      if(l>0) l=(1-d)*l;
      else l=(1+d)*l;
    }


    round_up();
    r=inter.right_b()+d;
  #endif
  interval rt=interval(l,r);
  return rt;
}



 interval inf_increase_interval(const interval &inter)
//  increases the diameter of <inter> by a tiny amount
{
  double d=1e-16;
  interval rt;

  const int maxIter=10;
  int iter=1;
  bool done=false;
  while((!done) && (iter <=maxIter)){
    rt=inf_increase_interval(inter,d);
    done=in(inter,rt,1);
    d*=2;
    iter++;
  }

  if(!done){
    cerr << "Error in <inf_increase_interval>  inter="  << inter << "  rt=" << rt << endl;
    ofstream report(zglerrorlogname,ios::app);
    entriesinerrorlog=1;
    report <<"************************" << endl;
    writeCompInfo(report);
    writedatetime(report);
    report << "Error in <inf_increase_interval>  inter="  << inter << "  rt=" << rt << endl;
    report << "Iter=" << iter << "   d=" << d << endl;
     #if defined(KRAK) && defined(WIN95)
                   waitBt();
    #endif
    exit(EXIT_FAILURE);
  }

  return(rt);
}




int thesameIbox(const interval m[],const interval n[],int dim)
// returns 1 when m[i]==n[i] for i=1,...,dim
//         0 otherwise
{
  int thesame=1;
  int i=1;
  while(thesame && (i<=dim)){
    thesame=(m[i]==n[i]);
    i++;
  }
  return thesame;
}


bool commonpart(const interval& x1,const interval& x2,interval *cp)
// on output:  cp =intersection of <x1> and <x2>
//  returns true - when it is nonempty
//          false - otherwise, in this case cp - is not changed
{
  bool nonempty;
  double l=x1.left_b();
  if(x2.left_b() > l) l=x2.left_b();
  double r=x1.right_b();
  if(x2.right_b() < r) r=x2.right_b();

  nonempty=(l<=r);
  if(nonempty)  *cp=interval(l,r);

  return(nonempty);
}

bool commonpart(const interval x1[],const interval x2[],interval cp[],int dim)
// cp[i]=commonpart(x1[i],x2[i]), for i=1..dim
//  returns true - when it is nonempty
//          false - otherwise, in this case cp - is not changed
{
  bool nonempty=true;
  interval *tcp;
  tcp=new interval[dim+1];
  for(int i=1;((i<=dim) && nonempty);i++)
    nonempty=commonpart(x1[i],x2[i],tcp+i);

  if(nonempty)
    copyvector(tcp,cp,dim);

  delete [] tcp;
  return(nonempty);
}

bool commonpart(const interval x1[][MAX_DIM+1],const interval x2[][MAX_DIM+1],
         interval cp[][MAX_DIM+1],int dim)
// cp[i][j]=commonpart(x1[i][j],x2[i][j]), for i,j=1..dim
//  returns true - when it is nonempty
//          false - otherwise, in this case cp - is not changed
{
  bool nonempty=true;
  interval t;
  intervalmatrix1 *tcp;
  tcp=new intervalmatrix1[dim+1];
  for(int i=1;((i<=dim) && nonempty);i++)
    for(int j=1;((j<=dim) && nonempty);j++){
      nonempty=commonpart(x1[i][j],x2[i][j],&t);
      tcp[i][j]=t;
    }

  if(nonempty)
    copymatrix(tcp,cp,dim);

  delete [] tcp;
  return(nonempty);
}



void MultiIhull(const interval m1[],const interval m2[],interval hull[],int pdim)
//  On output : hull=intervalhull(m1,m2);  pdim=dim(m1,m2,hull)
{
  for(int i=1;i<=pdim;i++)
    hull[i]=Ihull(m1[i],m2[i]);
}

void MultiIhull(const interval m1[][MAX_DIM+1],const interval m2[][MAX_DIM+1],
    interval hull[][MAX_DIM+1],int pdim)
//  On output : hull=intervalhull(m1,m2);  pdim=dim(m1,m2,hull)
{
  for(int i=1;i<=pdim;i++)
    for(int j=1;j<=pdim;j++)
      hull[i][j]=Ihull(m1[i][j],m2[i][j]);
}


int MultiIn(const interval m1[],const interval m2[], int interior,int pdim)
// return 1, when m1 \subset m2
//          if interior we require m1 \subset interior(m2)
//  pdim - dimension
{
 int retval=1;
 int i=1;
 while((i<=pdim) && retval){
   retval=(in(m1[i],m2[i],interior));
   i++;
 }
 return(retval);
}

int MultiIn(const double m1[],const  interval m2[], int interior,int pdim)
// returns 1, when m1 \in m2
//          if interior we require m1 \subset interior(m2)
//  pdim - dimension
{
  interval* im1;
  im1=new interval[pdim+1];
  tointerval(m1,im1,pdim);
  int ret=MultiIn(im1,m2,interior,pdim);
  delete [] im1;
  return ret;
}





void mid(const interval s[],interval t[],int pdim)
//  t=mid(s)
{
  for(int i=1; i<= pdim; i++)
    t[i]=mid(s[i]);
}



void mid(const interval s[][MAX_DIM+1],interval t[][MAX_DIM+1],int pdim)
//  t=mid(s)
{
  for(int i=1; i<= pdim; i++)
    for(int j=1;j<=pdim;j++)
      t[i][j]=mid(s[i][j]);
}


double MultiIDiam(const interval m[],int pdim,int normfunc)
// computes the norm (defined by <normfunc>) of the vector build form
//  diameters of <m>
{
  interval md[MAX_DIM+1];
  for(int i=1; i<= pdim; i++)
    md[i]=diameter(m[i]);
  return(abs(norm(md,pdim,normfunc)).right_b());
}

void MultiISplit(interval m[],double *diam,int pdim,int normfunc)
// on output m(input) \subset B(m(output),*diam)
// in a given norm; diameter(m(output))=0
{
  double temp=0;
  *diam=0.0;
  for(int i=1;i<=pdim; i++) {
    interval r=m[i];
    iSplit(&r,&temp);
    m[i]=r;
    if (temp > *diam) *diam=temp;
  }
  *diam=normIVect(interval(*diam),pdim,normfunc).right_b();
}

void MultiINeigh(const interval m[],interval diam, interval res[],int pdim)
// res = B_M(m,diam), a 'ball' of radius <diam> around m
{
  interval sdiam=Ihull(-diam,diam);

  for(int i=1; i <= pdim; i++)
    res[i]=m[i]+sdiam;

}

void DecomposeIMulti(interval m[],interval r[],int pdim)
// on output m(output) + r(output) \supset m(input)
// r(output)[i]=[-a_i,a_i] - i.e. is symmetric
// diam(m(output))=0
{
  double temp=0;
  interval iv;
  for(int i=1;i<=pdim; i++) {
    iv=m[i];
    iSplit(&iv,&temp);
    m[i]=iv;
    r[i]=interval(-temp,temp);
  }
}

double arrfabs(const interval m[],int pdim)
{
  double retval=abs(m[1]).right_b();
  double t;
  for(int i=2; i<=pdim; i++){
    t=abs(m[i]).right_b();
    if (t > retval)  retval=t;
  }
  return(retval);
}

void arrabs(const interval a[][MAX_DIM+1],double t[][MAX_DIM+1],int dim)
// on output:  t[i][j]=Right(abs(a[i][j]))
{
  for(int i=1;i<=dim;i++)
    for(int j=1;j<=dim;j++)
      t[i][j]=abs(a[i][j]).right_b();
}




interval smarteval_vAv(const interval c[],const interval a[][MAX_DIM+1],const interval b[],
      int dim)
// computes c^T*a*b
{
  interval res1=0;
  interval res2=0;
  for(int i=1;i<=dim;i++){
    interval t=0;
    for(int j=1;j<=dim;j++)
      t+=a[i][j]*b[j];
    res1+=c[i]*t;
  }

  for(int j=1;j<=dim;j++){
    interval t=0;
    for(int i=1;i<=dim;i++)
      t+=c[i]*a[i][j];
    res2+=t*b[j];
  }
  interval res;
  commonpart(res1,res2,&res);
  return(res);
}



void multAV(const interval m[][MAX_DIM+1],const interval x[], interval r[],int pdim)
     // r=m*x
{
  interval t;
  interval *rt;     // we use temporary variable, to avoid errors
       // when x[] and r[] are the same
  rt=new interval[pdim+1];
  for(int i=1;i<=pdim; i++){
    t=0.0;
    for(int j=1;j<=pdim;j++) t+=m[i][j]*x[j];
    rt[i]=t;
  }
  for(int i=1;i<=pdim;i++)
    r[i]=rt[i];
  delete [] rt;
}



void multAV(const double m[][MAX_DIM+1],const double x[], double r[],int pdim)
     // r=m*x
{
  double t;
  double rt[MAX_DIM+1]; // we use temporary variable, to avoid errors
       // when x[] and r[] are the same
  for(int i=1;i<=pdim; i++){
    t=0.0;
    for(int j=1;j<=pdim;j++) t+=m[i][j]*x[j];
    rt[i]=t;
  }
  for(int i=1;i<=pdim;i++)
    r[i]=rt[i];
}


void multAV(const double m[][MAX_DIM+1],const interval x[], interval r[],int pdim)
     // r=m*x
{
  intervalmatrix1 *im;
//  interval im[MAX_DIM+1][MAX_DIM+1];
  im=new intervalmatrix1[pdim+1];
  tointerval(m,im,pdim);
  multAV(im,x,r,pdim);
  delete [] im;
}


void ArrArr(const interval A[][MAX_DIM+1],const interval B[][MAX_DIM+1],
                     interval C[][MAX_DIM+1],int pdim)
  /* C=AB */
{
  intervalmatrix1 *Ct;
  Ct=new intervalmatrix1[pdim+1];
  interval t;
  for(int i=1; i<= pdim; i++)
    for(int j=1; j<= pdim; j++){
      t=0.0;

      for(int k=1;k<=pdim; k++)
        t+=A[i][k]*B[k][j];

      Ct[i][j]=t;
    }

  for(int i=1;i<=pdim;i++)
    for(int j=1;j<=pdim;j++)
      C[i][j]=Ct[i][j];
  delete [] Ct;
}


void ArrArr(const double A[][MAX_DIM+1],const interval B[][MAX_DIM+1],
       interval C[][MAX_DIM+1],int pdim)
  /* C=AB */
{
  intervalmatrix1 *IA;
  IA=new intervalmatrix1[pdim+1];
  tointerval(A,IA,pdim);
  ArrArr(IA,B,C,pdim);
  delete [] IA;
}

void ArrArr(const interval A[][MAX_DIM+1],const double B[][MAX_DIM+1],
        interval C[][MAX_DIM+1],int pdim)
  /* C=AB */
{
  intervalmatrix1 *IB;
  IB=new intervalmatrix1[pdim+1];
  tointerval(B,IB,pdim);
  ArrArr(A,IB,C,pdim);
  delete [] IB;
}

void ArrArr(const double A[][MAX_DIM+1],const double B[][MAX_DIM+1],
     double C[][MAX_DIM+1],int pdim)
  /* C=AB */
{
  double Ct[MAX_DIM+1][MAX_DIM+1];
  double t;
  for(int i=1; i<= pdim; i++)
    for(int j=1; j<= pdim; j++){
      t=0.0;

      for(int k=1;k<=pdim; k++)
        t+=A[i][k]*B[k][j];

      Ct[i][j]=t;
    }

  for(int i=1;i<=pdim;i++)
    for(int j=1;j<=pdim;j++)
      C[i][j]=Ct[i][j];
}



void transpose(const interval A[][MAX_DIM+1],interval C[][MAX_DIM+1],
         int pdim)
//  C=A^t
{

  interval aij;
  for(int i=1;i<=pdim;i++){
    for(int j=1;j<i;j++){
       aij=A[i][j]; // we proceed like this because we allow for A and C
                         // to be pointers to the same matrix
       C[i][j]=A[j][i];
       C[j][i]=aij;
    }
  }
  // now the diagonal elements
  for(int i=1;i<=pdim;i++)
    C[i][i]=A[i][i];

}


void transpose(const double A[][MAX_DIM+1],double C[][MAX_DIM+1],
         int pdim)
// C=A^t
{

  double aij;
  for(int i=1;i<=pdim;i++){
    for(int j=1;j<i;j++){
       aij=A[i][j];          // we proceed like this because we allow for A and C
                         // to be pointers to the same matrix
       C[i][j]=A[j][i];
       C[j][i]=aij;
    }
  }
  // now the diagonal elements
  for(int i=1;i<=pdim;i++)
    C[i][i]=A[i][i];

}


void transpose(const double A[][MAX_DIM+1],interval C[][MAX_DIM+1],
         int pdim)
// C=A^t
{

  interval aij;
  for(int i=1;i<=pdim;i++){
    for(int j=1;j<i;j++){
       aij=A[i][j];
       C[i][j]=aij;
       C[j][i]=aij;
    }
  }
  // now the diagonal elements
  for(int i=1;i<=pdim;i++)
    C[i][i]=A[i][i];

}




void copysection(const double S[],double T[],int pdim)
// the indices in section start form 0, hence we need different function
//   then copy vector
// T=S
{
  for(int i=0;i<=pdim; i++)
    T[i]=S[i];
}


void copysection(const interval S[],interval T[],int pdim)
// T=S
{
  for(int i=0;i<=pdim; i++)
    T[i]=S[i];
}

void copymatrix(const double S[][MAX_DIM+1],
    double T[][MAX_DIM+1],int pdim)
/* T=S */
{
  for(int i=1;i<=pdim; i++)
    for(int j=1; j<=pdim; j++)
      T[i][j]=S[i][j];
}

void copymatrix(const interval S[][MAX_DIM+1], interval T[][MAX_DIM+1],int pdim)
/* T=S */
{
  for(int i=1;i<=pdim; i++)
    for(int j=1; j<=pdim; j++)
      T[i][j]=S[i][j];
}


void copymatrix(const double S[][MAX_DIM+1],
                   interval T[][MAX_DIM+1],int pdim)
/* T=S */
{
  for(int i=1;i<=pdim; i++)
    for(int j=1; j<=pdim; j++)
      T[i][j]=interval(S[i][j]);
}




void identity(double m[][MAX_DIM+1],int dim)
// m=identity matrix
{
  for(int i=1;i<=dim;i++)
    for(int j=1;j<=dim;j++){
      m[i][j]=0.0;
      if(i==j) m[i][j]=1.0;
    }
}

void identity(interval m[][MAX_DIM+1],int dim)
// m=identity matrix
{
  for(int i=1;i<=dim;i++)
    for(int j=1;j<=dim;j++){
      m[i][j]=0.0;
      if(i==j) m[i][j]=1.0;
    }
}


void zero(interval v[],int dim)
// v[i]=0, i=0,dim
{
  for(int i=0;i<=dim;i++)
    v[i]=0.0;
}

void zero(double v[],int dim)
// v[i]=0, i=0,dim
{
  for(int i=0;i<=dim;i++)
    v[i]=0.0;
}


void zero(interval m[][MAX_DIM+1],int dim)
// m=zero matrix
{
  for(int i=1;i<=dim;i++)
    for(int j=1;j<=dim;j++){
      m[i][j]=0.0;
    }
}

void zero(double m[][MAX_DIM+1],int dim)
// m=zero matrix
{
  for(int i=1;i<=dim;i++)
    for(int j=1;j<=dim;j++){
      m[i][j]=0.0;
    }
}



void split(interval m[][MAX_DIM+1],interval r[][MAX_DIM+1],
             int dim)
//  m(input) \subset m(output)+r(output)
//   diam(m(output))=0
{
  interval z;
  for(int i=1;i<=dim;i++)
    for(int j=1;j<=dim;j++){
      m[i][j].split(z);
      r[i][j]=z;
    }
}


interval inflate(const interval &c,const interval & f)
// on output an interval <interout> is returned such that
//  center(interout)=center(c) and diam(interout)=f*diam(c)
{
  interval interout=c;
  interval z;
  interout.split(z);
  z=z*Right(f);
  interout+=z;
  return interout;
}


void ArrInflate(interval t[],interval c, int dim)
{
  for(int i=1;i<=dim;i++)
    t[i]=inflate(t[i],c);
}


interval diameter(const interval m[][MAX_DIM+1],int dim)
{
  interval ret=0.0;
  for(int i=1;i<=dim;i++)
    for(int j=1;j<=dim;j++){
      interval d=diameter(m[i][j]);
      ret=Ihull(ret,d);
    }
  return(Right(ret));
}


interval diameter(const interval m[],int dim)
{
  interval ret=0.0;
  for(int i=1;i<=dim;i++){
    interval d=diameter(m[i]);
    ret=Ihull(ret,d);
  }
  return(Right(ret));
}



double trace2x2(const double a[][MAX_DIM+1])
// dim a = 2;   trace2x2=Trace (a)
{
  return(a[1][1]+a[2][2]);
}



double det2x2(const double a[][MAX_DIM+1])
//  dim a =2; det2x2=det(a)
{
  return(a[1][1]*a[2][2]-a[1][2]*a[2][1]);
}


int inverse(const double a[][MAX_DIM+1],double r[][MAX_DIM+1],int dim)
//  r=a^{-1} ;; dim must be 1 or 2
{
  if(dim==1){
    if(a[1][1]==0.0){
      #if defined(WIN95) && defined(KRAK)
        rootFrame.Clear();
      #endif
      cerr << "Singular matrix: inverse "  << endl;
      #if defined(WIN95) && defined(KRAK)
        cerr << "press any key " << endl;
        waitBt();
      #endif
      exit(EXIT_FAILURE);
      return 0;
    }
    r[1][1]=1.0/a[1][1];
    return 1;
  }
  if(dim != 2){
    #if defined(WIN95) && defined(KRAK)
      rootFrame.Clear();
    #endif
    cerr << "Too big dimension in inverse (<=2 ), here" << dim << endl;
    #if defined(WIN95) && defined(KRAK)
      cerr << "press any key " << endl;
      waitBt();
    #endif
    exit(EXIT_FAILURE);
  }
  double det=det2x2(a);

  if(det==0.0){
   #if defined(WIN95) && defined(KRAK)
      rootFrame.Clear();
    #endif
    cerr << "Singular matrix: inverse "  << endl;
    #if defined(WIN95) && defined(KRAK)
      cerr << "press any key " << endl;
      waitBt();
    #endif
    exit(EXIT_FAILURE);
  }

  det=1.0/det;
  r[1][1]=det*a[2][2];
  r[1][2]=-det*a[1][2];
  r[2][1]=-det*a[2][1];
  r[2][2]=det*a[1][1];
  return 1;
}



int   d2invmatrix(const interval m[][MAX_DIM+1], interval inv[][MAX_DIM+1],int dim )
// dim must be equal to 2
{
  // we have to compute inverse of invmac
  // for a matrix  A C
  //               B D
  // the inverse is given by:
  //               D/W   -C/W
  //              -B/W    A/W
  // where w=determinant AD - BC

  if(dim != 2){
    #if defined(WIN95) && defined(KRAK)
      rootFrame.Clear();
    #endif
    cerr << "Too big dimension in inverse (<=2 ), here" << dim << endl;
    #if defined(WIN95) && defined(KRAK)
      cerr << "press any key " << endl;
      waitBt();
    #endif
    return 0;
  }


  interval a,b,c,d,w;
  a=m[1][1];
  c=m[1][2];
  b=m[2][1];
  d=m[2][2];

  w=a*d - b*c;


  if(w.contains(0.0)){
    return(0);
  }

  inv[1][1]=d/w;
  inv[1][2]=-c/w;
  inv[2][1]=-b/w;
  inv[2][2]=a/w;

  return 1;
}


int diag2x2(const double df[][MAX_DIM+1],double *lambda1,double vec1[],
   double *lambda2,double vec2[])
//  dim df=2
//  On output : (lambda1,vec1) - pair of eigenvalue and eigenvector
//              (lambda2,vec2) -   ''
// this procedure assumes that lambda1,lambda2 are real
//   and there is no nontrival Jordan cell
{
  // the characteristic polynomial is given by : x^2 - tr(df)x + det(df)
  double delta,tr,det;
  tr=df[1][1]+df[2][2];
  det=df[1][1]*df[2][2] - df[1][2]*df[2][1];
  delta=tr*tr - 4*det;
  if(delta < 0){
    #if defined(WIN95) && defined(KRAK)
      rootFrame.Clear();
    #endif
    cerr << "diag2x2 - cannot linearize " << endl;
    #if defined(WIN95) && defined(KRAK)
      cerr << "Press any key " << endl;
      waitBt();
    #endif
    exit(EXIT_FAILURE);
  }
  *lambda1=(tr + sqrt(delta))/2;
  *lambda2=(tr - sqrt(delta))/2;

  int ret=0;
  int casenum=3; // diagonal
  if(fabs(df[1][2]) > fabs(df[2][1])){
    casenum=1;
  }
  if(fabs(df[2][1]) > fabs(df[1][2])){
    casenum=2;
  }


  if(casenum==1){ // df[1][2] !=0
    ret=1;
    vec1[1]=1.0;
    vec1[2]=((*lambda1) - df[1][1])/df[1][2];

    vec2[1]=1.0;
    vec2[2]=((*lambda2) - df[1][1])/df[1][2];
  }
  if(casenum==2){ // df[2][1]!=0
    ret=1;
    vec1[2]=1;
    vec1[1]=((*lambda1) -df[2][2])/df[2][1];

    vec2[2]=1;
    vec2[1]=((*lambda2) -df[2][2])/df[2][1];
  }
  if(casenum==3){ // diagonal
    ret=1;
    if(fabs(df[1][1]-(*lambda1)) <= fabs(df[1][1]-(*lambda2))){
      vec1[1]=1.0;
      vec1[2]=0.0;
      vec2[1]=0.0;
      vec2[2]=1.0;
    }else{
      vec1[1]=0.0;
      vec1[2]=1.0;
      vec2[1]=1.0;
      vec2[2]=0.0;
    }
  }

  if(ret){
    vect_normalize(vec1,2,NORM_EUCL);
    vect_normalize(vec2,2,NORM_EUCL);
  }

  return(ret);
}


int diag2x2(const interval df[][MAX_DIM+1],interval *lambda1,interval vec1[],
   interval *lambda2,interval vec2[])
//  dim df=2
//  On output : (lambda1,vec1) - pair of eigenvalue and eigenvector
//              (lambda2,vec2) -   ''
// the procedure assumes that lambda1,lamda2 are real
//   and there is no nontrival Jordan cell
// the function is not really finished, it does not treat the situation,
// when both off-diagonal terms contain 0
{
  // the characteristic polynomial is given by : x^2 - tr(df)x + det(df)
  interval delta,tr,det;
  tr=df[1][1]+df[2][2];
  det=df[1][1]*df[2][2] - df[1][2]*df[2][1];
  delta=tr*tr - 4*det;
  if(!(delta >= 0)){
    #if defined(WIN95) && defined(KRAK)
      rootFrame.Clear();
    #endif
    cerr << "diag2x2 - cannot linearize " << endl;
    #if defined(WIN95) && defined(KRAK)
      cerr << "Press any key " << endl;
      waitBt();
    #endif
    return 0;
  }
  *lambda1=(tr + sqrt(delta))/2;
  *lambda2=(tr - sqrt(delta))/2;

  int ret=0;
  int casenum=0;
  if(!df[1][2].contains(0) && !df[2][1].contains(0)){
    if(Left(abs(df[2][1])) >= Left(abs(df[1][2]))){
      casenum=1;
    }else casenum=2;
  }
  if(casenum==0){
    if(!df[1][2].contains(0))
      casenum=1;
    if(!df[2][1].contains(0))
      casenum=2;
  }
  if(casenum==0){ // both off-diagonal terms contain 0
    // do nothing, but later I may need to fill this in
  }

  if(casenum==1){ // df[1][2] !=0
    ret=1;
    vec1[1]=1.0;
    vec1[2]=((*lambda1) - df[1][1])/df[1][2];

    vec2[1]=1.0;
    vec2[2]=((*lambda2) - df[1][1])/df[1][2];
  }
  if(casenum==2){ // df[2][1]!=0
    ret=1;
    vec1[2]=1;
    vec1[1]=((*lambda1) -df[2][2])/df[2][1];

    vec2[2]=1;
    vec2[1]=((*lambda2) -df[2][2])/df[2][1];
  }

  if(ret){
    vect_normalize(vec1,2,NORM_EUCL);
    vect_normalize(vec2,2,NORM_EUCL);
  }



  return(ret);
}









interval scprod(const interval x[],const interval y[],int pdim)
     /* calculates scalar product of two vectors*/
{
  interval r=0;
  int i;
  for(i=1;i<=pdim;i++) r+=x[i]*y[i];
  return(r);
}

double scprod(const double x[],const double y[],int pdim)
     /* calculates scalar product of two vectors*/
{
  double r=0;
  for(int i=1;i<=pdim;i++) r+=x[i]*y[i];
  return(r);
}

double evalsection(const double sec[],const double x[],int dim)
// the evaluation of the section form <sec> on <x>
{
  double r=sec[0];
  for(int i=1;i<=dim;i++)
    r+=sec[i]*x[i];
  return(r);
}


interval evalsection(const interval sec[],const interval x[],int dim)
// the evaluation of the section form <sec> on <x>
{
  interval r=sec[0];
  for(int i=1;i<=dim;i++)
    r+=sec[i]*x[i];
  return(r);
}



void dropcoord(const double Dx[][MAX_DIM+1],int coord, double Dp[][MAX_DIM+1],int dim)
  // from <dim> x <dim> matrix Dx the <coord> row and columns are
  // removed, result is placed in <Dp>
  // function used in computation of Jacobian of Poincare map
{
  for(int i=1;i<=dim;i++){
    int i1;
    if(i<coord) i1=i;
    if(i>coord) i1=i-1;
    if(i!=coord){
      for(int j=1;j<=dim;j++){
        int j1;
        if(j<coord) j1=j;
        if(j>coord) j1=j-1;
        if(j!=coord)
            Dp[i1][j1]=Dx[i][j];
      }
    }
  }
}

void dropcoord(const double D3in[][MAX_DIM+1][MAX_DIM+1],int coord,double  D3out[][MAX_DIM+1][MAX_DIM+1],int dim)
//  from dim x dim x dim matrix D3in
//  we delete all entries with the index i - and the resulting matrix is D3out
{
  int i1;
  for(int i=1;i<=dim;i++){
    if(i<coord) i1=i;
    if(i>coord) i1=i-1;
    if(i!=coord){
      dropcoord(D3in[i],coord,D3out[i1],dim);
    }
  }
}


void dropcoord(const double xin[],int coord,double xout[],int dim)
// From the <dim>-dimensional vector <xin> we drop <coord>-th coordinate
//  the resulting vector is stored in <xout>
{
  int j=0;
  for(int i=1;i<=dim;i++)
    if(i!=coord){
      j++;
      xout[j]=xin[i];
    }
}

void dropcoord(const interval xin[],int coord,interval xout[],int dim)
// From the <dim>-dimensional vector <xin> we drop <coord>-th coordinate
//  the resulting vector is stored in <xout>
{
  int j=0;
  for(int i=1;i<=dim;i++)
    if(i!=coord){
      j++;
      xout[j]=xin[i];
    }
}

void insertcoord(const interval xin[],int coord,interval xout[],interval valcoord,
        int dim)
//  We modify <dim-1>-dimesional vector <xin>, by inserting on <coord>'s slot
//  the value <valcoord>  the resulting vector <dim>-dimensional vector
//  is stored in <xout>
{
  interval t[MAX_DIM+1]; // we use this auxliary variable to allow
     // for the same vector xin and xout in the parameters
  for(int i=1;i<=dim;i++){
    if(i<coord) t[i]=xin[i];
    if(i==coord) t[i]=valcoord;
    if(i>coord) t[i]=xin[i-1];
  }
  copyvector(t,xout,dim);
}


void dropcoord(const interval Dx[][MAX_DIM+1],int coord,interval Dp[][MAX_DIM+1],int dim)
  // from <dim> x <dim> matrix Dx the <coord> row and columns are
  // removed, result is placed in <Dp>
  // function used in computation of Jacobian of Poincare map
{
  for(int i=1;i<=dim;i++){
    int i1;
    if(i<coord) i1=i;
    if(i>coord) i1=i-1;
      if(i!=coord){
        for(int j=1;j<=dim;j++){
          int j1;
          if(j<coord) j1=j;
          if(j>coord) j1=j-1;
          if(j!=coord)
            Dp[i1][j1]=Dx[i][j];
        }
      }
  }
}


void insertcoord(const interval Din[][MAX_DIM+1],int coord,
                        interval Dout[][MAX_DIM+1],int dim)
  // In the <dim-1> x <dim-1> matrix <Din> we insert new coordinate
  //   this means new row (==0) and column (==0) - in the <coord> position
  //  result is placed in <Dout>
{
//  interval t[MAX_DIM+1][MAX_DIM+1];
  intervalmatrix1 *t;
  t=new intervalmatrix1[dim+1];
  for(int i=1;i<=dim;i++){
    if(i< coord) copyvector(Din[i],t[i],dim-1);
    if(i==coord){
      for(int j=1;j<=dim-1;j++)
        t[i][j]=0.0;
    }
    if(i>coord) copyvector(Din[i-1],t[i],dim-1);
    insertcoord(t[i],coord,t[i],0.0,dim);
  }

  copymatrix(t,Dout,dim);
  delete [] t;
}


int finddropcoord(const double sec[],int dim)
// function tries to test if sec is really of the form:
//   x_i = c_i ;
// in this case <i> is returned, otherwise 0
{
  double tiny=1e-10;
  int bigcount=0;
  int retval=0;
  for(int i=1;i<=dim;i++){
    if(fabs(sec[i]) > tiny){
      bigcount++;
      retval=i;
    }
  }
  if(bigcount!=1) retval=0;
  return(retval);

}

int finddropcoord(const interval sec[],int dim)
// function tries to test if sec is really of the form:
//   x_i = c_i ;
// in this case <i> is returned, otherwise 0
{
  int bigcount=0;
  int retval=0;
  for(int i=1;i<=dim;i++){
    if(abs(sec[i]).right_b() !=0.0){
      bigcount++;
      retval=i;
    }
  }
  if(bigcount!=1) retval=0;
  return(retval);
}

// INVERSE MATRIX - PRIMITIVE COMPUTATION OF DETERMINANT , INVERSE VIA
//                   KRAMERS FORMULA

void  matrixdelrowcol(const interval m[][MAX_DIM+1],int row,int col,
             interval md[][MAX_DIM+1],int dim)
// the function deletes from <m> (dim x dim )-matrix
//  <row>-th row and <col>-th column to create <md>
{
   for(int r=1;r<=dim-1;r++){
     int rm=r;
     if(r>= row) rm=r+1;
     for(int c=1;c<=dim-1;c++){
       int cm=c;
       if(c >=col) cm=c+1;
       md[r][c]=m[rm][cm];
     }
   }
}


interval det(const interval m[][MAX_DIM+1],int dim)
//  returns the determinant by developing along the first row
//  det=\sum_{j=1}^dim (-1)^{i+j} det({\hat m}_{i,j})
//  where {\hat m}_{i,j} is the matrix obtained from <m> by removing
//  i-th row and j-th column
{
  interval ret=0.0;
  if(dim==1)
    ret=m[1][1];
  else{
//    interval md[MAX_DIM+1][MAX_DIM+1];
    intervalmatrix1 *md;
    md=new intervalmatrix1[dim+1];
    int row=1;
    for(int j=1;j<=dim;j++){
      matrixdelrowcol(m,row,j,md,dim);
      int sign=1;
      if( ((row+j) % 2) ==1) sign=-1;
      ret+=sign*m[row][j]*det(md,dim-1);
    }
    delete [] md;
  }
  return ret;
}

int kramers_inverse(const interval m[][MAX_DIM+1],interval minv[][MAX_DIM+1],int dim)
// on output m^{-1} \subset minv
// 1 - is returned if the inverse of <m> exists, <dim> - the dimension of <m>
//  Algorithm - the Kramers formula
//      m^{-1}_{ij}=(-1)^{i+j} det ({\hat m}_{j,i})/det(m)
//  where {\hat m}_{i,j} is the matrix obtained from <m> by removing
//  i-th row and j-th column
{
  int ok;
  interval deter=det(m,dim);
  ok=!(deter.contains(0.0));
  if(ok){
    intervalmatrix1 *t;
    t=new intervalmatrix1[dim+1];
    intervalmatrix1 *inv;
    inv=new intervalmatrix1[dim+1];
    for(int i=1;i<=dim;i++)
      for(int j=1;j<=dim;j++){
        int sign=1;
        if( (i+j) % 2 ==1) sign=-1;
        matrixdelrowcol(m,j,i,t,dim);
        inv[i][j]=sign*det(t,dim-1)/deter;
      }
    copymatrix(inv,minv,dim);
    delete [] t;
    delete [] inv;
  }
  return ok;
}


// INVERSE MATRIX END


//  INVERSE MATRIX VIA GAUSS ELIMINATION

// ------------- Gauss elimination ------------------------------- //
int gauss_elim(const interval ai[][MAX_DIM+1],const interval bi[],interval res[],int dim)
    // on output res = ai^{-1} * bi - using the Gauss elimination
    //   dim - the dimension of ai,bi,res
    //  1- is returned when everything is ok.
    //  0 - otherwise
    //  Adapted from Vect-Alg - author: M. Mrozek
{
  int ok=1;
  intervalmatrix1 *a;
  a=new intervalmatrix1[dim+1];

  interval b[MAX_DIM+1];
  copymatrix(ai,a,dim);
  copyvector(bi,b,dim);

  int i,j,k,p[MAX_DIM+1];

  // p - is the permutation  for the rows (equations)
  //    after the permutation p[i] -is the i-th  row

  for(i=1;i<=dim;i++) p[i]=i;

  for(j=1;((j<dim) && ok);j++){

    interval a_max,a_max_temp;
    int i_max,temp;
    a_max=abs(a[p[j]][j]); // it might have better sense to take Left(abs(...))
    i_max=j;
    for(i=j+1;i<=dim;i++){
      if( (a_max_temp=abs(a[p[i]][j]))>a_max ){
        a_max=a_max_temp;
        i_max=i;
      }
    }
    temp=p[j];
    p[j]=p[i_max];
    p[i_max]=temp;



    interval divisor=a[p[j]][j];
    if( divisor.contains(0) ){
      ok=0;
    }


    if(ok){
      for(i=j+1;i<=dim;i++){
        interval factor=a[p[i]][j]/a[p[j]][j];
        a[p[i]][j]=0;
        b[p[i]]-=factor*b[p[j]];
        for(k=j+1;k<=dim;k++){
          a[p[i]][k]-=factor*a[p[j]][k];
        }
      }
    }
  }


  if(ok){ // we need to check it because, it was'nt check in the loop before
    if(a[p[dim]][dim].contains(0))
      ok=0;
  }


  // solving the upper triangular system A*res=b
  // taking into account the permutation A
  if(ok){
    for(i=dim;((i>=1) && ok);i--){
      res[i]=b[p[i]];
      for(j=i+1;j<=dim;j++)
        res[i]-=a[p[i]][j]*res[j];

      res[i]/=a[p[i]][i];
    }
  }

  delete [] a;
  return ok;
}

int inverse(const interval m[][MAX_DIM+1],interval minv[][MAX_DIM+1],int dim)
// on output m^{-1} \subset minv
// 1 - is returned if inverse of <m> exists, <dim> - the dimension of <m>
//  Algorithm - Gauss elimination
{
  int ok=1;
  interval* b;
  b=new interval[dim+1];
  intervalmatrix1 *tminv;
  tminv=new intervalmatrix1[dim+1];
  for(int i=1;((i<=dim) && ok);i++){
    zero(b,dim);
    b[i]=1.0;
    ok=gauss_elim(m,b,tminv[i],dim);
  }
  if(ok) transpose(tminv,minv,dim);
  delete [] tminv;
  delete [] b;
  return ok;

}

int precond_inverse(const interval m[][MAX_DIM+1],interval minv[][MAX_DIM+1],int dim)
// on output m^{-1} \subset minv
// 1 - is returned if the inverse of <m> exists, <dim> - the dimension of <m>
// 0 - otherwise
//  Algorithm - the Gauss elimination; we use mid(minv) as an initial guess
//     to the inverse
{
  intervalmatrix1 *mi[2];
  int ok[2];

  for(int i=0;i<2;i++){
    mi[i]=new intervalmatrix1[dim+1];
  }
  ok[0]=inverse(m,mi[0],dim);

  /// preconditionining
  intervalmatrix1 *mic=new intervalmatrix1[dim+1];
  mid(minv,mic,dim);
  ArrArr(m,mic,mi[1],dim); // mi[1]=m*mic
  ok[1]=inverse(mi[1],mi[1],dim); // mi[1]=(m*mic)^{-1}=mic^{-1}*m^{-1}
  if(ok[1]){
    ArrArr(mic,mi[1],mi[1],dim); //  mi[1]=mic*(m*mic)^{-1}
  }
  delete [] mic;
  ///
  if(!ok[0]){
    if(ok[1]){
      ok[0]=1;
      copymatrix(mi[1],mi[0],dim);
    }
  }
  if(!ok[1]){
    if(ok[0]){
      ok[1]=1;
      copymatrix(mi[0],mi[1],dim);
    }
  }

  int retval=0;

  if(ok[0] && ok[1]){
    retval=commonpart(mi[0],mi[1],minv,dim);
    if(!retval){
      cerr << "precond_inverse - very serious error " << endl;
       #if defined(KRAK) && defined(WIN95)
                     waitBt();
    #endif
      exit(EXIT_FAILURE);
    }
  }


  for(int i=0;i<2;i++)
    delete [] mi[i];

  return retval;
}

//  END - INVERSE MATRIX GAUSS ELIMINATION




int pos_defined(interval m[][MAX_DIM+1],int dim)
// m is dim x dim - dimensional matrix
// On output 1 - when m is positively defined
//           0 - otherwise
{
  int pos=1;
  int i=1;
  while((i <= dim) && pos){
    if(det(m,i)>0){
      pos=1;
    }else{
      pos=0;
    }
    i++;
  }
  return pos;
}






/// RANDOM NUMBERS

double zglrandom(double d,double u)
// function generates random number from the interval [d,u]
{
  long bignumber=2147483647;  //pow(2,31) - 1;
  long randnumber;
  #ifdef BORLAND
    randnumber=random(bignumber);
  #else
    randnumber=rand();
  #endif
    // the random integer we have is from 0 to bignumber
    // we have to rescale (map) (0,bignumber)  onto (d,u)
    // transformation is given by:
    //  a*x + b
    //  b=d
    //  a*bignumber+b = u
  double b=d;
  double a=(u-b)/bignumber;
  return(a*randnumber + b);
}



// END-RANDOM NUMBERS



// NORMS



interval normMax(const interval x[],int pdim)
{
 interval ret=0;
 for(int i=1; i<= pdim; i++)
   {
     if (abs(x[i]).right_b() > ret) ret=abs(x[i]).right_b();
   }
 return(ret);
}

double normMax(const double x[],int pdim)
{
 double ret=0;
 for(int i=1; i<= pdim; i++)
   {
     if (fabs(x[i]) > ret) ret=fabs(x[i]);
   }
 return(ret);
}




interval normEucl(const interval x[],int pdim)
{
  interval ret=0.0;
  for(int i=1; i<= pdim; i++) ret+=power(x[i],2);
  return(sqrt(ret));

}


double normEucl(const double x[],int pdim)
{
  double ret=0.0;
  for(int i=1; i<= pdim; i++) ret+=pow(x[i],2);
  return(sqrt(ret));

}


interval normSum(const interval x[],int pdim)
{
  interval ret=0;
  for(int i=1; i<= pdim; i++) ret+=abs(x[i]);
  return(ret);
}

interval normSum(const interval m[][MAX_DIM+1],int pdim)
{
  interval ret=0;
  for(int i=1;i<=pdim;i++){
    interval s=0;
    for(int j=1;j<=pdim;j++)
      s+=abs(m[j][i]);
    if(Right(s) > ret)
      ret=Right(s);
  }
  return ret;
}


double normSum(const double m[][MAX_DIM+1],int pdim)
{
  double ret=0;
  for(int i=1;i<=pdim;i++){
    double s=0;
    for(int j=1;j<=pdim;j++)
      s+=abs(m[j][i]);
    if(Right(s) > ret)
      ret=Right(s);
  }
  return ret;
}

interval normIVect(const interval & x,int pdim,int normfunc)
// returns the norm of  x^pdim=(x,x,...,x) - pdim-times repeated x
{
  if(normfunc==NORM_MAX)
    return(abs(x)) ;


  if(normfunc==NORM_SUM)
    return(interval(pdim)*abs(x));


  if(normfunc==NORM_EUCL)
    return(sqrt(interval(pdim))*abs(x));

  return(0.0);
}


interval norm(const interval x[],int pdim,int normfunc)
{
  if(normfunc==NORM_MAX)
    return(normMax(x,pdim)) ;

  if(normfunc==NORM_SUM)
    return(normSum(x,pdim));

  if(normfunc==NORM_EUCL)
    return(normEucl(x,pdim));
  return(0);
}

interval norm(const interval m[][MAX_DIM+1],int pdim, int normfunc)
{
  if(normfunc==NORM_MAX)
    return(normMax(m,pdim)) ;

  if(normfunc==NORM_SUM)
    return(normSum(m,pdim));

  if(normfunc==NORM_EUCL)
    return(normEucl(m,pdim));
  return(0);
}

double norm(const double m[][MAX_DIM+1],int pdim, int normfunc)
{
  if(normfunc==NORM_MAX)
    return(normMax(m,pdim)) ;

  if(normfunc==NORM_SUM)
    return(normSum(m,pdim));

  if(normfunc==NORM_EUCL)
    return(normEucl(m,pdim));
  return(0);
}


interval gradNormEucl(const interval x[],int pdim)
  //  computes eculidean norm of the 'gradient' i.e.
  //   vector of the form i*x[i], i=1..pdim
{
  interval y[MAX_DIM+1];
  for(int i=1; i<=pdim; i++)
    y[i]=i*x[i];
  return(normEucl(y,pdim));
}



double gradNormEucl(const double x[],int pdim)
  //  computes eculidean norm of the 'gradient' i.e.
  //   vector of the form i*x[i], i=1..pdim
{
  double y[MAX_DIM+1];
  for(int i=1; i<=pdim; i++)
    y[i]=i*x[i];
  return(normEucl(y,pdim));
}



double norm(const double x[],int pdim,int normfunc)
{
  interval xi[MAX_DIM+1];
  for(int i=1; i<= pdim; i++)
    xi[i]=x[i];
  return(abs(norm(xi,pdim,normfunc)).right_b());
}


int vect_normalize(interval Vector[],int pdim,int normfunc)
// a normalization
// ON OUTPUT: 1-is returned if 0 \notin Vector  and Vector/=Norm(Vector)
//            0 - is returned if 0 \in Vector
{
  interval Vnorm;
  int ret=1;
  Vnorm=norm(Vector,pdim,normfunc);
  if (in(0.0,Vnorm)) {
    ret=0;
  }
  if (ret){
    for(int i=1; i<=pdim; i++)
    Vector[i]/=Vnorm;
  }
  return(ret);
}

int vect_normalize(double Vector[],int pdim,int normfunc)
// normalisation
// ON OUTPUT: 1-is returned if Vector in nonzero and Norm(Vector)=1
//            0 - is returned if Vector==0
{
  double Vnorm;
  int ret=1;
  Vnorm=norm(Vector,pdim,normfunc);
  if (Vnorm==0.0) {
    ret=0;
  }
  if (ret){
    for(int i=1; i<=pdim; i++)
    Vector[i]/=Vnorm;
  }
  return(ret);
}





void vectminvect(interval x[], interval y[],interval r[],int pdim)
/* r= x - y */
{
  int i;
  for(i=1;i<=pdim; i++) r[i]=x[i]-y[i];
}



interval normEucl(const interval m[][MAX_DIM+1],int pdim)
// returns an approximate euclidean operator norm of a matrix <m>
//   pdim - the dimension of <m>
{
//  interval s[MAX_DIM+1][MAX_DIM+1];
  intervalmatrix1 *s;
  s=new intervalmatrix1[pdim+1];
  interval x[MAX_DIM+1],xn[MAX_DIM+1],delta[MAX_DIM+1];
  interval r;
  int i,j,k;
  int max_il_iter;
  max_il_iter=5*pdim;


  for(i=1;i<=pdim; i++)
    for(j=1;j<=pdim; j++){
      r=0.0;
      for(k=1;k<=pdim; k++){
        r+=m[i][k]*m[j][k];
      }
      s[i][j]=r;
    }

  for(i=1;i<=pdim;i++){
     x[i]=0.0;
     xn[i]=1.0/i;
  }


  vect_normalize(xn,pdim,NORM_EUCL);

  k=0;
  do{
    k++;
    for(i=1;i<=pdim;i++) x[i]=xn[i];

    multAV(s,x,xn,pdim);
    vect_normalize(xn,pdim,NORM_EUCL);
    vectminvect(x,xn,delta,pdim);
  }while ((norm(delta,pdim,NORM_EUCL) > 0.01) && (k<=max_il_iter));


  multAV(s,x,xn,pdim);


  delete [] s;
  return( sqrt(norm(xn,pdim,NORM_EUCL)/norm(x,pdim,NORM_EUCL)));

}

double normEucl(const double m[][MAX_DIM+1],int pdim)
 // returns an approximate euclidean operator norm of a matrix <m>
//   pdim - the dimension of <m>
{
//  interval mi[MAX_DIM+1][MAX_DIM+1];
  intervalmatrix1 *mi;
  mi=new intervalmatrix1[pdim+1];
  for(int i=1;i<=pdim;i++)
    for(int j=1;j<=pdim;j++)
      mi[i][j]=m[i][j];
  double ret= normEucl(mi,pdim).right_b();
  delete [] mi;
  return ret;
}



interval normMax(const interval D[][MAX_DIM+1],int pdim)
{
  interval ret=0.0;
  interval m;
  int i,j;
  for(i=1; i<= pdim; i++){
    m=0.0;
    for(j=1;j<=pdim; j++)
      m+=abs(D[i][j]);
    if(Right(m)>ret)
      ret=Right(m);
  }
  return(ret);
}

double normMax(const double D[][MAX_DIM+1],int pdim)
{
  double ret=0.0;
  double m;
  for(int i=1; i<= pdim; i++){
    m=0;
    for(int j=1;j<=pdim; j++)
      m+=fabs(D[i][j]);
    if (m > ret) ret=m;
  }
  return(ret);
}




double distNormMax(const double x[],const double y[],int pdim)
{
  double z[MAX_DIM+1];
  for(int i=1;i<=pdim;i++)
    z[i]=x[i]-y[i];
  return(normMax(z,pdim));
}

double distNormEucl(const double x[],const double y[],int pdim)
{
  double z[MAX_DIM+1];
  for(int i=1;i<=pdim;i++)
    z[i]=x[i]-y[i];
  return(normEucl(z,pdim));
}



double distNormMax(const double x[][MAX_DIM+1],const double y[][MAX_DIM+1],
     int pdim)
{
  double z[MAX_DIM+1][MAX_DIM+1];
  for(int i=1;i<=pdim;i++)
    for(int j=1;j<=pdim;j++)
      z[i][j]=x[i][j]-y[i][j];
  return(normMax(z,pdim));
}
// end of former content of norms.cpp


// logarthmic_norms


interval lognormMax(const interval x[][MAX_DIM+1],int pdim)
// the logarithmic norm induced by the "max norm" (L_\infty- norm) |x|=\max |x_i|
// returns upper bound - an interval of zero-width
{
  interval ret=0.0;
  interval temp;
  for(int i=1;i<=pdim; i++){
    temp=0;
    for(int j=1; j<= pdim; j++){
      if (i==j)
        temp+=x[i][j];
      else
        temp+=abs(x[i][j]);
    }
    if(Right(temp) > ret)
      ret=Right(temp);
  }
  return(ret);
}


interval lognormSum(const interval x[][MAX_DIM+1],int pdim)
// the logarithmic norm induced by the "sum norm" (L_1- norm) |x|=\sum |x_i|
// returns upper bound - an interval of zero-width
{
  interval ret=0.0;
  interval temp;
  for(int j=1;j<=pdim; j++){
    temp=0;
    for(int i=1; i<= pdim; i++){
      if (i==j)
        temp+=x[i][j];
      else
        temp+=abs(x[i][j]);
    }
    if(Right(temp)>ret)
      ret=Right(temp);
  }
  return(ret);
}




interval logarithmic_norm(const interval x[][MAX_DIM+1],int pdim,int normfunc)
//  returns logarithmic norm of x (an upper bound);
//  when we use the euclidean norm - the procedure
//    is not rigorous; for max and sum - the function is rigorous
{
  interval ret=0;
  if(normfunc==NORM_MAX)  ret=lognormMax(x,pdim);
  if(normfunc==NORM_SUM)  ret=lognormSum(x,pdim);
  if(normfunc==NORM_EUCL){
    cerr << "Euclidean logarithmic norm is not implemented " << endl;
     #if defined(KRAK) && defined(WIN95)
                   waitBt();
    #endif
    exit(EXIT_FAILURE);
  }
  return ret;
}



double lognormMax(const double x[][MAX_DIM+1],int pdim)
// the logarithmic norm induced by the "max norm" (L_\infty- norm) |x|=\max |x_i|
{
  double ret=0.0;
  double temp;
  for(int i=1;i<=pdim; i++){
    temp=0;
    for(int j=1; j<= pdim; j++){
      if (i==j)
        temp+=x[i][j];
      else
        temp+=fabs(x[i][j]);
    }
    if(Right(temp) > ret)
      ret=Right(temp);
  }
  return(ret);
}


double lognormSum(const double x[][MAX_DIM+1],int pdim)
// the logarithmic norm induced by the "sum norm" (L_1- norm) |x|=\sum |x_i|
{
  double ret=0.0;
  double temp;
  for(int j=1;j<=pdim; j++){
    temp=0;
    for(int i=1; i<= pdim; i++){
      if (i==j)
        temp+=x[i][j];
      else
        temp+=fabs(x[i][j]);
    }
    if(Right(temp)>ret)
      ret=Right(temp);
  }
  return(ret);
}


double lognormEucl(const double x[][MAX_DIM+1],int pdim)
// the logarithmic norm induced by the "max norm" (L_\infty- norm) |x|=\max |x_i|
{

  doublematrix1 *xsym=new doublematrix1[pdim+1];
  for(int i=1;i<=pdim;i++)
    for(int j=1;j<=pdim; j++)
      xsym[i][j]=(x[i][j] + x[j][i])/2;

  double ret=lognormMax(xsym,pdim);
  delete [] xsym;
  return ret;
}

double logarithmic_norm(const double x[][MAX_DIM+1],int pdim,int normfunc)
//  returns logarithmic norm of x (an upper bound);
{
  double ret=0;
  if(normfunc==NORM_MAX)  ret=lognormMax(x,pdim);
  if(normfunc==NORM_SUM)  ret=lognormSum(x,pdim);
  if(normfunc==NORM_EUCL) ret=lognormEucl(x,pdim);

  return ret;
}


// end of logarithmic_norms



int intab(int k,const int tab[],int istart,int iend,int *indk)
// 1 - is returned if k=tab[j] for some istart<= j <= iend, on output*ind=j
// 0 otherwise
{
  int ret=0;
  *indk=istart-1;
  for(int i=istart;i<=iend;i++)
    if(tab[i]==k){
       ret=1;
       *indk=i;
    }

  return(ret);
}


char* norm_name(char* name,int maxlen, int norm_type)
{
  strcpy(name,"");
  if(norm_type==NORM_SUM)
    strncpy(name,"L_1-norm",maxlen-1);
  if(norm_type==NORM_EUCL)
    strncpy(name,"euclidean norm ",maxlen-1);
  if(norm_type==NORM_MAX)
    strncpy(name,"L-infinity norm",maxlen-1);
  return name;
}



interval hausdorff_dist(interval u,interval v)
// returns the hausdorff distance between u and v
{
  interval d1=Right(abs(Left(u) - Left(v)));
  interval d2=Right(abs(Right(u) - Right(v)));
  return Right(Ihull(d1,d2));
}


int gennewseqi(int seq[],const int l[], int pos, int dim)
//   the function generates the next sequence of integers in lexigraphic order
//  the matrixes <seq>, <l> have dimension <dim>
//  the range of integers in the i-th entry in matrix <seq> is
//   0,....,l[i]-1
//   pos - we are allowed to change  <pos,pos+1,...,dim> entries
//               in <seq>
//  The input sequence is in <seq>
//  1- is returned if we can generate a new sequence, which is then stored in <seq>
//  0 - otherwise
//////
//  the smallest seqence: seq[i]=0
//   the largest one seq[i]=l[i]-1
{
  if(pos > dim) return 0;
  (seq[pos])++;
  if(l[pos]==seq[pos]){
    if(pos==dim) return(0);
    else{
      seq[pos]=0;
      return(gennewseqi(seq,l,pos+1,dim));
    }
  }
  return(1);
}

void divide_set(int dim,const int seq[],const int divisiontable[],
       int divdim,const interval ixb[],const interval C[][MAX_DIM+1],const interval r0[],
       interval pixb[],interval pr0[])
 //  we  divide
 //  the set ixb + C*r0 into \Pi_{1<= i <=divdim}  divisiontable[i] parts
 //  the i-th direction in <r0> is divided into divisiontable[i] equal parts
 //  seq[i] for i=1,\dots,divdim , specifies the corresponding part
 //  seq[i]\in \{0,\dots,divisiontable[i]-1 \}
 //////////
 //  On output: the part corresponding to <seq> is given by
 //            pixb + C*pr0

{
  copyvector(ixb,pixb,dim);
  for(int i=1;i<=divdim;i++){
    interval len=(Right(r0[i])-Left(r0[i]))/divisiontable[i];
    interval leftend=Left(r0[i]) + seq[i]*len;
    pr0[i]=leftend + interval(0,len.right_b());
  }
  for(int i=divdim+1;i<=dim;i++)
    pr0[i]=r0[i];

  interval pr0mid[MAX_DIM+1];
  copyvector(pr0,pr0mid,dim);
  DecomposeIMulti(pr0mid,pr0,dim);  // now the part corresponding
     // to <seq> has the form   pixb + C(pr0mid + pr0), diam(pixb)=0=diam(pr0mid)
  multAV(C,pr0mid,pr0mid,dim);   // pr0mid=C*promid
  for(int i=1;i<=dim;i++)
    pixb[i]+=pr0mid[i];
}


void divide_set(int dim,const int seq[],const int divisiontable[],int divdim,
                              interval r0[],interval pr0[])
 //  we  divide
 //  the set r0 into \Pi_{1<= i <=divdim}  divisiontable[i] parts
 //  the i-th direction in <r0> is divided into divisiontable[i] equal parts
 //  seq[i] for i=1,\dots,divdim , specifies the corresponding part
 //  seq[i]\in \{0,\dots,divisiontable[i]-1 \}
 //////////
 //  On output: the part corresponding to <seq> is given by pr0
{
  for(int i=1;i<=divdim;i++){
    interval len=(Right(r0[i])-Left(r0[i]))/divisiontable[i];
    interval leftend=Left(r0[i]) + seq[i]*len;
    pr0[i]=leftend + interval(0,len.right_b());
  }
  for(int i=divdim+1;i<=dim;i++)
    pr0[i]=r0[i];

}

interval orthogonalcomponent(interval Vect[], interval Vnorm[],int pdim)
// on output <Vect> is equal to   Vect - <Vect|Vnorm>Vnorm
// i.e. we subtract from <Vect> its projection on <Vnorm>
//   function assumes that <VNorm> is normalized
//  we return <Vect|VNorm>
{

  int i;
  interval prod=0.0;
  for(i=1;i<=pdim; i++)
    prod+=Vect[i]*Vnorm[i];

  for(i=1; i<=pdim; i++)
    Vect[i]-=prod*Vnorm[i];

  return(prod);
}

double orthogonalcomponent(double Vect[], double Vnorm[],int pdim)
// on output <Vect> is equal to   Vect - <Vect|Vnorm>Vnorm
// i.e. we subtract from <Vect> its projection on <Vnorm>
//   function assumes that <VNorm> is normalized
//  we return <Vect|VNorm>

{
  int i;
  double prod=0.0;
  for(i=1;i<=pdim; i++)
    prod+=Vect[i]*Vnorm[i];

  for(i=1; i<=pdim; i++)
    Vect[i]-=prod*Vnorm[i];

  return(prod);
}



bool orthogonalize(double q[][MAX_DIM+1],int pdim,int vectnum)
//  the function orthogonalizes <pdim>-dimensional vectors
//     q[1],q[2],\dots,q[vectnum]
//  On output:
//     q - contains orthonormalized vectors
//     1 - is returned if everything went ok
//     0 - otherwise (the vector of zero length was encountered during
//         orthogonalisation
//  the real number is considered to be effectively zero when it
//    is less than <smalldouble=1e-12>

{
  double smalldouble=1e-12;

  bool ok=true;
  int vno=1;
  while(ok && (vno<=vectnum)){
    for(int vj=1;vj < vno;vj++){
      orthogonalcomponent(q[vno],q[vj],pdim); // it subtracts from q[vno] its
                                             // projection onto q[vj]
    }
    double c=normEucl(q[vno],pdim);
    if(fabs(c) < smalldouble) ok=0;
    else for(int i=1;i<=pdim;i++) q[vno][i]/=c;

    vno++;
  }
  return(ok);
}





bool orthogonalize(interval q[][MAX_DIM+1],int pdim,int vectnum)
//  the function orthogonalizes <pdim>-dimensional vectors
//     q[1],q[2],\dots,q[vectnum]
//  On output:
//     q - contains orthonormalized vectors
//     true - is returned if everything went ok
//     false - otherwise (the vector of zero length was encountered during
//         orthogonalisation
{

  bool ok=true;
  int vno=1;
  while(ok && (vno<=vectnum)){
    for(int vj=1;vj < vno;vj++){
      orthogonalcomponent(q[vno],q[vj],pdim);  // it subtracts from q[vno] its
                                             // projection onto q[vj]
    }
    interval c=normEucl(q[vno],pdim);
    if(c.contains(0.0)) ok=false;
    else for(int i=1;i<=pdim;i++) q[vno][i]/=c;




    vno++;
  }
  return(ok);
}


int solve_ax_r(interval a, interval *x, interval r)
// finds x, such that r \subset a* x
// we look for x with possibly small diameter
{
  int ok=1;
  if(!a.contains(0)){
    *x=r/a;
    return ok;
  }

  if((-a.left_b()==a.right_b()) && (-r.left_b()==r.right_b())){
    // the system is symmetric
    if(a.right_b()==0){ // a==0
      if(r.right_b()==0){ // r==0
        *x=0;
      }else{
        ok=0;
      }
    }else{
      *x=Right(r)/Right(a);
    }
  }else{
    // we first transform the system: [r \subset a*x] into a normal form
    // so that abs(a.re) >= abs(a.le) and abs(r.re) >= abs(r.le), and r.re >=0
    // this is achieved by sign changes of a and r - each such sign change
    // is compensated by a sign change of x
    int sign=1;
    if(-a.left_b() > a.right_b()){
      a=-a;
      sign=-sign;
    }
    if(r <0){
      r=-r;
      sign=-sign;
    }
    if(r.contains(0)){
      if(-r.left_b() > r.right_b()){
        r=-r;
        sign=-sign;
      }
    }
    // now our system is in the normal form
    if(a.right_b()==0){ // a==0
      if(r.right_b()==0){ // r==0
        *x=0;
      }else{
        ok=0;
      }
    }else{ // a!=0
      interval xre,xle;
      xre=Right(r)/Right(a);
      if(r >=0){
        xle=xre;   // this is ok, because a*(xle,xre)=(0,r.re) contains r
      }else{  // r - contains 0
        if(Left(a)*xre <= Left(r)){
          xle=xre;
        }else{
          xle=Left(r)/Right(a);
        }
      }
      *x=Ihull(xle,xre);
    }
    if(ok)
      *x=sign*(*x);
  }
  return ok;
}

// #define TEST_MATRIX_EXP

bool matrixexp(const interval a[][MAX_DIM+1],int dim,interval res[][MAX_DIM+1])
//  this is an 'old' function, the 'new' one is <smart_matrixexp>
// on output: res=exp(a)
// true - is returned when the computation was sucessful (convergence criterion
//           are met
//  false - otherwise
{
  double eps=1e-1;
  const int max_N=100;
  const int normfunc=NORM_MAX; // only NORM_MAX and NORM_SUM -can be used -
                // NORM_EUCL - is not rigorous


  interval norm_a=Right(norm(a,dim,normfunc));

  intervalmatrix1 *an;
  an=new intervalmatrix1[dim+1];
  identity(an,dim);

  identity(res,dim);
  bool done=false;
  int n=1;
  while(!done && (n <=max_N)){
    ArrArr(an,a,an,dim);  // an=a*an
    for(int i=1;i<=dim;i++){
      for(int j=1;j<=dim;j++)
        an[i][j]/=n;
    }
    for(int i=1;i<=dim;i++){
      for(int j=1;j<=dim;j++){
        res[i][j]+=an[i][j];
      }
    }
    // now an=a^n/(n!)
    if(norm_a < 2*(n+1)){ // in this case we have the estimate
                      //  |\sum_{k=1}^\infty A^{k+n}/(n+1)!| \leq |A^n|/n! \sum_{k=1}^\infty (|A|/(n+1))^k
                      //  \leq  |A^n|/n! |A|/(n+1) 1/(1-|A|/(n+1))
      interval norm_an=Right(norm(an,dim,normfunc));
      interval q=norm_a/(n+1);
      interval normres=Right(norm(res,dim,normfunc));
      if((q/(1-q) < eps) && (norm_an < eps*normres) ){
        done=true;
        interval rem=norm_an*q/(1-q);
        rem=Ihull(-rem,rem);
        for(int i=1;i<=dim;i++){
          for(int j=1;j<=dim;j++){
            res[i][j]+=rem;
          }
        }
      }
    }
    n++;
  }
  delete [] an;
  return done;
}


bool test_stop_exp(const int dim,const double expA[][MAX_DIM+1],
          const double An[][MAX_DIM+1],const double A[][MAX_DIM+1],
                 const int n,const double eps,
             const int normf)
  //  normf - either NORM_MAX or NORM_SUM   (L_\infty or L_1, respectively)
  // expA=\sum_{i=0}^n A^i/i!
  //   An=A^n/n!
  //  the remainder in the exp expression is estimated as follows
  //  |A^{n+k}/(n+k)!| \leq |An| * (|A|/(n+1))^k
  //  It can be estimated  by geometric series if r=(|A|/(n+1)) < 1
  // and in this case we obtain
  //   |\sum_{k>n} A_k| \leq |An|r/(1-r) = R_n
  ///   we want R_n < eps*|expA|
{

  bool retval=false;

  double r=norm(A,dim,normf)/(n+1);
  #if defined(TESTY_MATRIX_EXP)
  cout << "n=" << n << "  r=" << r << endl;
  #endif
  if(r<1){
    double rem=norm(An,dim,normf)*r/(1-r);
    retval=(rem < eps*norm(expA,dim,normf));
  }

  return retval;
}


bool matrixexp(const double A[][MAX_DIM+1],const int dim,double expA[][MAX_DIM+1])
// on output expA=exp(A)
//    the iteration is continued  till certain criteria are met
// if not then <false> is returned
{
  const int max_iter=1000;
  double eps=1e-2;
  identity(expA,dim);

  doublematrix1 *An=new doublematrix1[MAX_DIM+1];
  identity(An,dim); // this will be A^n/n!

  bool finished=false;

  int iter=1;
  while((iter <=max_iter)  && (!finished)){
    ArrArr(An,A,An,dim);
    for(int i=1;i<=dim;i++){
      for(int j=1;j<=dim;j++)
        An[i][j]/=iter;
    }
    for(int i=1;i<=dim;i++){
      for(int j=1;j<=dim;j++)
        expA[i][j]+=An[i][j];
    }
    finished=test_stop_exp(dim,expA,An,A,iter,eps,NORM_MAX);
    iter++;
  }

  delete [] An;
  return finished;
}

bool smart_matrixexp(const double A[][MAX_DIM+1],const int dim,double expA[][MAX_DIM+1],
         int level /* =0 */)
// on output expA=exp(A)
//   if A - has too large norm, then exp(A) is computed by exp(A)=exp(A/2)*exp(A/2)
//       and exp(A/2)   might require another computation of expA/4) etc
//   this is a recursive function
//  level - indicates how deep in the recurrence are we
{
  double bigNorm=3.0;

  bool retval=false;
  double normA=norm(A,dim,NORM_MAX);
  if(normA > bigNorm){
    doublematrix1* An=new doublematrix1[dim+1];
    for(int i=1;i<=dim;i++)
      for(int j=1;j<=dim;j++)
        An[i][j]=A[i][j]/2;

    retval=smart_matrixexp(An,dim,expA,level+1);
    if(retval)
      ArrArr(expA,expA,expA,dim);

    delete [] An;
  }else{
    retval=matrixexp(A,dim,expA);
  }
  return retval;
}

bool smart_matrixexp(const interval A[][MAX_DIM+1],const int dim,interval expA[][MAX_DIM+1],
         int level /* =0 */)
// on output expA=exp(A)
//   if A - has too large norm, then exp(A) is computed by exp(A)=exp(A/2)*exp(A/2)
//       and exp(A/2)   might require another computation of expA/4) etc
//   this is a recursive function
//  level - indicates how deep in the recurrence are we
{
  interval bigNorm=3.0;

  bool retval=false;
  interval normA=Right(norm(A,dim,NORM_MAX));
  if(normA > bigNorm){
    intervalmatrix1* An=new intervalmatrix1[dim+1];
    for(int i=1;i<=dim;i++)
      for(int j=1;j<=dim;j++)
        An[i][j]=A[i][j]/2;

    retval=smart_matrixexp(An,dim,expA,level+1);
    if(retval)
      ArrArr(expA,expA,expA,dim);

    delete [] An;
  }else{
    retval=matrixexp(A,dim,expA);
  }
  return retval;
}





void wrongdiminfo(int dim1,int dim2,const char procname[])
{
  cerr << "in function [" << procname << "] wrong dimensions " << dim1 << "   "<< dim2  << endl;
  #if defined(KRAK) && defined(WIN95)
    waitBt();
  #endif
}

